from CvPythonExtensions import *
import CvConfigParser
import os

gc = CyGlobalContext()

pConfig = CvConfigParser.CvConfigParser("zMax Units Config.ini")

def getNumAllowed(iPlayer):
	pPlayer = gc.getPlayer(iPlayer)

	iUnitsPerCity = pConfig.getint("City Support", gc.getWorldInfo(CyMap().getWorldSize()).getType(), pConfig.getint("City Support", "iDefaultCitySupport", 0))

	fNumCitiesChange = pConfig.getfloat("zMax Units Data", "fNumCitiesChange", 0.0)

	iMinNumSupported = pConfig.getint("zMax Units Data", "iMinNumSupported", 0)
	
	if pPlayer.isHuman():
		iUnitsBonus = pConfig.getint("Diff Bonus", gc.getHandicapInfo(CyGame().getHandicapType()).getType() + " Human", 0)
	else:
		iUnitsBonus = pConfig.getint("Diff Bonus", gc.getHandicapInfo(CyGame().getHandicapType()).getType() + " AI", 0)

	iUnitsPerCitySpeed = pConfig.getint("Game Speed", gc.getGameSpeedInfo(CyGame().getGameSpeedType()).getType(), 0)

	iUnitsPerCity += iUnitsPerCitySpeed

	allowed = 0

	for iCity in range(pPlayer.getNumCities()):
		allowed += max(iMinNumSupported, iUnitsPerCity + int(float(iCity) * fNumCitiesChange))


	if allowed > 0:
		allowed += iUnitsBonus

	return allowed

def percentOfAllowed(iPlayer):
	num = getNumAllowed(iPlayer)

	if num < 1:
		return 0.0
	return (100.0 / float(num)) * float(getNumUnits(iPlayer))

def getNumUnits(iPlayer):
	pPlayer = gc.getPlayer(iPlayer)

	return pPlayer.getNumMilitaryUnits()

def canContinue():
	return pConfig.getboolean("zMax Units Data", "bAllowContinue", False)