from CvPythonExtensions import *
import CvConfigParser

gc = CyGlobalContext()

pConfig = CvConfigParser.CvConfigParser("zMax Units Config.ini")

class zMaxUnitsEventManager:
	def __init__(self, eventManager):
		eventManager.addEventHandler("BeginPlayerTurn", self.onBeginPlayerTurn)

	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		iGameTurn, iPlayer = argsList

		pPlayer = gc.getPlayer(iPlayer)
		iMaxForceUpgrades = pConfig.getint("zMax Units Data", "iMaxAIUnitForceUpgrades", 0)
		if not pPlayer.isHuman() and not pPlayer.isBarbarian() and iMaxForceUpgrades > 0:
			num = 0
			for iUnit in range(pPlayer.getNumUnits()):
				pUnit = pPlayer.getUnit(iUnit)
				upgradesTo = self.getUnitUpgrades(pUnit)
				canUpgradeRand = CyGame().getSorenRandNum(100, "Force Upgrade")
				if upgradesTo != [] and canUpgradeRand < 75:
					rand = CyGame().getSorenRandNum(len(upgradesTo), "Force Upgrade")
					cost = pUnit.upgradePrice(upgradesTo[rand])
					if cost < pPlayer.getGold():
						pUnit.doCommand(CommandTypes.COMMAND_UPGRADE, upgradesTo[rand], upgradesTo[rand])
						num += 1
				if num >= iMaxForceUpgrades:
					break

	def getUnitUpgrades(self, Unit):
		upgradeTypes = []
		uType = gc.getUnitInfo(Unit.getUnitType())
		pPlayer = gc.getPlayer(Unit.getOwner())
		for iUnit in range(gc.getNumUnitInfos()):
			pUnit = gc.getUnitInfo(iUnit)
			if not uType == None and uType.getUpgradeUnitClass(pUnit.getUnitClassType()):
				upgradeTypes.append(iUnit)
		return upgradeTypes